// Do not include this file directly, use xml-schema.hxx instead. This
// file is included into generated xml-schema.hxx so we do not need to
// guard against multiple inclusions.
//

#include <string>

namespace xml_schema
{
  class type: public type_base
  {
  public:
    type ();
    type (const xercesc::DOMElement&, flags = 0, container* = 0);
    type (const xercesc::DOMAttr&, flags = 0, container* = 0);
    type (const std::string&, const xercesc::DOMElement*,
          flags = 0, container* = 0);
    type (const type&, flags = 0, container* = 0);

    virtual type*
    _clone (flags = 0, container* = 0) const;

  public:
    // Element name and namespace.
    //
    const std::string&
    _name () const
    {
      return name_;
    }

    const std::string&
    _namespace () const
    {
      return namespace_;
    }

    void
    _name (const std::string& n)
    {
      name_ = n;
    }

    void
    _namespace (const std::string& ns)
    {
      namespace_ = ns;
    }

  private:
    std::string name_;
    std::string namespace_;
  };

  // New element serialization operator.
  //
  void
  operator<< (xercesc::DOMElement&, const type&);
}
